// serverv3.c
// This is a server that accepts a string and checks it's correctness.
// After accepting a connection, the server will exit if 30 seconds
// pass and the connections is not completed.

#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>

void SIGALRM_handler(int status)
{
	printf("Too slow.\n");
	exit(0);
}

void error(char *msg)
{
    perror(msg);
    exit(1);
}

char VonClausewitz[] = "Where two ideas form a true logical antithesis, each complementary to the other, then fundamentally each is implied in the other.  If the limitations of our mind do not allow us to comprehend both simultaneously, and discover by antithesis the whole of one in the whole of the other, each will nevertheless shed enough light on the other to clarify many of its details.  In consequence we believe that the earlier chapters about defense will have sufficiently illuminated the aspects of attack on which they touch.  But this is not always so.  No analytical system can ever be explored exhaustively.  It is natural that, where the antithesis does not lie so close to the root of the concept as in the previous chapters, what we can say about attack will not follow directly from what was said there about defense.  A shift in our viewpoint will bring us nearer the subject, so that we can examine more closely what we previously surveyed from a distance.  This will supplement our previous analysis; and what will now be said about attack will frequently also cast more light on defense.";


int main(int argc, char *argv[])
{
	int sockfd, newsockfd, portno, clilen;
	char Input[4096];

	struct sockaddr_in serv_addr, cli_addr;
	int n;
	int val = 1;

	struct itimerval ThirtySeconds = {{30, 0}, {30, 0}};

	if (argc < 2) {
		fprintf(stderr,"ERROR, no port provided\n");
		exit(1);
	}

	sockfd = socket(AF_INET, SOCK_STREAM, 0);
	if (sockfd < 0) 
		error("ERROR opening socket");
	bzero((char *) &serv_addr, sizeof(serv_addr));
	portno = atoi(argv[1]);
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = htons(portno);
 	setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &val, sizeof(val));
	if (bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) 
		error("ERROR on binding");

	listen(sockfd, 5);
	clilen = sizeof(cli_addr);
	newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
	if (newsockfd < 0) 
		error("ERROR on accept");

	dup2(newsockfd, 0);
	dup2(newsockfd, 1);

	bzero(Input,4096);
	fprintf(stdout, "What is Prof. Crandall (a.k.a. Jed, a.k.a. J-Dub, whatever you prefer)'s favorite Von Clausewitz quote?\n");
	
	signal(SIGALRM, SIGALRM_handler);
	setitimer(ITIMER_REAL, &ThirtySeconds, NULL);

	fflush(stdout);

	fgets(Input, 4095, stdin);
	
	if (strncmp(Input, VonClausewitz, strlen(VonClausewitz) - 1) == 0)
	{
		printf("Success!\n");
	}
	else
	{
		printf("Sorry, try again.\n");
	}

	close(newsockfd);
	close(sockfd);

	return 0; 
}
